<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
	<link rel="shortcut icon" type="image/x-icon" href="/static/images/pfavicon.ico" />
    <title>Creating Real-Time Charts with Flask</title>
    <link href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.3.1/css/bootstrap.min.css" rel="stylesheet">
    <link href="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.8.0/Chart.min.css" rel="stylesheet">
	<script src="/static/RGraph/libraries/RGraph.common.core.js"></script>
	<script src="/static/RGraph/libraries/RGraph.common.dynamic.js"></script>
	<script src="/static/RGraph/libraries/RGraph.meter.js"></script>
	<link href="/static/css/main.css" rel="stylesheet">
</head>
</head>
<body>
  <nav class="navbar navbar-dark" style="background-color:#FFFFFF;border-bottom: 5px solid#425563">
	<div class="container-logo">
        <a href="/" title="">
            <img src="/static/images/pf_logo.svg" title="" alt="">
        </a>
        <img class="claim" src="/static/images/claim.png">
	</div>
  </nav>
 <style>
 .colCard{
	padding:20px;
 }
 
 </style>

<div class="container" id="chartContainer" style='max-width:100%'>
    <div class="row">
        <div class="col-6 colCard">
            <div class="card">
                <div class="card-body">
                    <canvas id="chart1"></canvas>
                </div>
            </div>
        </div>
		<div class="col-6 colCard">
			<div class="card">
				<div class="card-body">
					<canvas id="chart2"></canvas>
				</div>
			</div>
		</div>
    </div>
	<div class="row">
        <div class="col-6 colCard">
            <div class="card" style="height:100%">
                <div class="card-body">
                    <div id="chart3">
						<div class="row">
							<div class="col" id="chart3_title" style="font-size:30px"></div>
						</div>
						<div class="row">
							<div class="col" id="chart3_data" style="font-size:30px"></div>
						</div>
					</div>
                </div>
            </div>
        </div>
		<div class="col-6 colCard">
			<div class="card">
				<div class="card-body">
					<div id="chart4">
						<!--<div><img class="turrentType" src="/static/images/TRedOff.png"></div>
						<div><img class="turrentType" src="/static/images/TYellowOff.png"></div>
						<div><img class="turrentType" src="/static/images/TGreenOff.png"></div>
						<div><img class="turrentType" src="/static/images/TBlueOff.png"></div>
						<div><img class="turrentType" src="/static/images/TBase.png"></div>-->
					</div>
				</div>
			</div>
		</div>
    </div>

</div>
<!-- Footer -->
<footer class="page-footer font-small blue" style="background:#00A587">
  <!-- Copyright -->
  <div class="footer-copyright text-center py-3" style="color:#FFFFFF;padding-top:50px!important;padding-bottom:50px!important">© 2020 Copyright:
    <a style="color:#FFFFFF" href="https://www.pepperl-fuchs.com/">Pepperl+Fuchs</a>
  </div>
  <!-- Copyright -->

</footer>
<!-- Footer -->
<!--suppress JSUnresolvedLibraryURL -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.0/jquery.min.js"></script>
<!--suppress JSUnresolvedLibraryURL -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.3.1/js/bootstrap.min.js"></script>
<!--suppress JSUnresolvedLibraryURL -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.8.0/Chart.min.js"></script>

<script>
    // Create the Meter chart - it must be assigned to a variable in
    // this case so that that variable can be used later.
    // Now add a click event listener so that when the canvas is clicked on
    // the Meter chart needle animates to show the new value.
    /*
	meter.canvas.onclick = function (e)
    {
        var newvalue = meter.getValue(e);
        
        meter.value = newvalue;
        meter.grow();
    }
	*/
</script>
<script>
    $(document).ready(function () {
        
		
		{% for each in serverJsonData %}
			{% if each["chartType"] == "Text"%}
				//alert('{{each["name"]}}')
				$('#{{each["name"]}}').html("Loading data...");
				//var canvas = document.getElementById("myCanvas");
				ctx_{{each["name"]}} = document.getElementById('{{each["name"]}}').getContext('2d');
				ctx_{{each["name"]}}.font = "30px Arial";
				ctx_{{each["name"]}}.fillText("Loading Chart", 10, 100);
				ctx_{{each["name"]}}.fillText('{{each["title"]}}', 0, 50);
				const source_{{each["name"]}} = new EventSource("/OPCUAClient?node={{each['node']}}");
					source_{{each["name"]}}.onmessage = function (event) {
						const data = JSON.parse(event.data);
						ctx_{{each["name"]}}.clearRect(0, 0, $('#{{each["name"]}}').width(), $('#{{each["name"]}}').height());
						ctx_{{each["name"]}}.fillText('{{each["title1"]}}', 0, 50);
						ctx_{{each["name"]}}.fillText(data.value/{{each["ValueDiv"]}}+ ' {{each["yAxes"]}}', 10, 100);
					}
			{% elif each["chartType"] == "RFIDText"%}
				$('#{{each["name"]}}_title').html("{{each['title1']}}");
				$('#{{each["name"]}}_data').html("Loading Data");
				const source_{{each["name"]}} = new EventSource("/OPCUAClient2?node1={{each['node']}}");
					source_{{each["name"]}}.onmessage = function (event) {
						const data = JSON.parse(event.data);
						$('#{{each["name"]}}_data').html(hex_to_ascii(data.value));
					}
			{% elif each["chartType"] == "Turrent"%}
				turrentRed='<div class="turrentDiv"><img id="tred" class="turrentType" src="/static/images/TRedOff.png"></div>';
				turrentYellow='<div class="turrentDiv"><img id="tyellow" class="turrentType" src="/static/images/TYellowOff.png"></div>';
				turrentGreen='<div class="turrentDiv"><img id="tgreen" class="turrentType" src="/static/images/TGreenOff.png"></div>';
				turrentBlue='<div class="turrentDiv"><img id="tblue" class="turrentType" src="/static/images/TBlueOff.png"></div>';
				turrentBase='<div class="turrentDiv"><img id="tbase" class="turrentType" src="/static/images/TBase.png"></div>';
				turrentValue='<div id="{{each["name"]}}_turrentValue">Value:</div>';
				turret=turrentRed+turrentGreen+turrentBlue+turrentBase+turrentValue;
				$('#{{each["name"]}}').html(turret)
				/*$('.turrentType').each(function(i, obj) {
					size=$(this).height();
					$(this).height(size*{{each["turrentImgScale"]}})
				});*/
					size=146;
					$("#tred").height(size*{{each["turrentImgScale"]}})
					size=110;
					$("#tyellow").height(size*{{each["turrentImgScale"]}})
					size=109;
					$("#tgreen").height(size*{{each["turrentImgScale"]}})
					size=111;
					$("#tblue").height(size*{{each["turrentImgScale"]}})
					size=249;
					$("#tbase").height(size*{{each["turrentImgScale"]}})
				
				const source_{{each["name"]}} = new EventSource("/OPCUAClient2?node1={{each['node']}}");
					source_{{each["name"]}}.onmessage = function (event) {
						const data = JSON.parse(event.data);
						newdata=data.value;
						if (newdata[1]==0){
							$("#tred").attr("src","/static/images/TRedOff.png");
							$("#tyellow").attr("src","/static/images/TYellowOff.png");
							$("#tgreen").attr("src","/static/images/TGreenOff.png");
							$("#tblue").attr("src","/static/images/TBlueOff.png");
						}
						if (newdata[1]==1){
							$("#tred").attr("src","/static/images/TRedOn2.png");
							$("#tyellow").attr("src","/static/images/TYellowOff.png");
							$("#tgreen").attr("src","/static/images/TGreenOff.png");
							$("#tblue").attr("src","/static/images/TBlueOff.png");
						}
						if (newdata[1]==2){
							$("#tred").attr("src","/static/images/TRedOff.png");
							$("#tyellow").attr("src","/static/images/TYellowOff.png");
							$("#tgreen").attr("src","/static/images/TGreenOn2.png");
							$("#tblue").attr("src","/static/images/TBlueOff.png");
						}						
						if (newdata[1]==3){
							$("#tred").attr("src","/static/images/TRedOn2.png");
							$("#tyellow").attr("src","/static/images/TYellowOff.png");
							$("#tgreen").attr("src","/static/images/TGreenOn2.png");
							$("#tblue").attr("src","/static/images/TBlueOff.png");
						}		
						if (newdata[1]==4){
							$("#tred").attr("src","/static/images/TRedOff.png");
							$("#tyellow").attr("src","/static/images/TYellowOff.png");
							$("#tgreen").attr("src","/static/images/TGreenOff.png");
							$("#tblue").attr("src","/static/images/TBlueOn2.png");
						}	
						if (newdata[1]==5){
							$("#tred").attr("src","/static/images/TRedOn2.png");
							$("#tyellow").attr("src","/static/images/TYellowOff.png");
							$("#tgreen").attr("src","/static/images/TGreenOff.png");
							$("#tblue").attr("src","/static/images/TBlueOn2.png");
						}						
						if (newdata[1]==6){
							$("#tred").attr("src","/static/images/TRedOff.png");
							$("#tyellow").attr("src","/static/images/TYellowOff.png");
							$("#tgreen").attr("src","/static/images/TGreenOn2.png");
							$("#tblue").attr("src","/static/images/TBlueOn2.png");
						}	
						if (newdata[1]==7){
							$("#tred").attr("src","/static/images/TRedOn2.png");
							$("#tyellow").attr("src","/static/images/TYellowOff.png");
							$("#tgreen").attr("src","/static/images/TGreenOn2.png");
							$("#tblue").attr("src","/static/images/TBlueOn2.png");
						}				
						$('#{{each["name"]}}_turrentValue').html("Value:["+newdata[1]+"]");
					}
			{% else %}
						{% if each["chartType"] != "RGraph.Meter"%}
								ctx_{{each["name"]}} = document.getElementById('{{each["name"]}}').getContext('2d');
								
								config_{{each["name"]}}= {
								type: '{{each["chartType"]}}',
								data: {
									labels: [],
									datasets: [{
										label: '{{each["datasetLabel"]}}',
										backgroundColor: '{{each["backgroundColor"]}}',
										borderColor: '{{each["borderColor"]}}',
										data: [],
										fill: false,
									}],
								},
								options: {
									responsive: true,
									title: {
										display: true,
										text: '{{each["title1"]}}'
									},
									tooltips: {
										mode: 'index',
										intersect: false,
									},
									hover: {
										mode: 'nearest',
										intersect: true
									},
									scales: {
										xAxes: [{
											display: true,
											scaleLabel: {
												display: true,
												labelString: '{{each["xAxes"]}}'
											}
										}],
										yAxes: [{
											display: true,
											scaleLabel: {
												display: true,
												labelString: '{{each["yAxes"]}}'
											},
											ticks: {
												max: {{each["max"]}},
												min: {{each["min"]}},
												stepSize: {{each["stepSize"]}}
											}
										}]
									}
								}
							};
							lineChart_{{each["name"]}}=new Chart(ctx_{{each["name"]}}, config_{{each["name"]}});
							
							const source_{{each["name"]}} = new EventSource("/OPCUAClient?node={{each['node']}}");
							source_{{each["name"]}}.onmessage = function (event) {
								const data = JSON.parse(event.data);
								if (config_{{each["name"]}}.data.labels.length === 20) {
									config_{{each["name"]}}.data.labels.shift();
									config_{{each["name"]}}.data.datasets[0].data.shift();
								}
								config_{{each["name"]}}.data.labels.push(data.time);
								config_{{each["name"]}}.data.datasets[0].label= "Last value: "+data.value/{{each["ValueDiv"]}};
								config_{{each["name"]}}.data.datasets[0].data.push(data.value/{{each["ValueDiv"]}});
								lineChart_{{each["name"]}}.update();
							}
					{% else %}
						    meter_{{each["name"]}} = new RGraph.Meter({
							id: '{{each["name"]}}',
							min: 0,
							max: 100,
							value: 15,
							options: {

								marginLeft: 15,
								marginRight: 15,
								marginTop: 15,
								marginBottom: 15,

								// There's various configuration options here so that the Meter looks
								// quite different to the default.
								backgroundColor: 'black',
								anglesStart: RGraph.PI - 0.55,
								anglesEnd: RGraph.TWOPI + 0.5,
								centery: 150,
								textSize: 14,
								textColor: 'white',
								textValign: 'center',
								colorsGreenColor: '#0a0',
								segmentsRadiusStart: 95,
								border: 0,
								tickmarksSmallCount: 0,
								tickmarksLargeCount: 0,
								needleRadius: 70,
								needleColor: '#ddd',
								needleHeadWidth: 0.1,
								needleHeadLength: 20,
								centerpinStroke: 'black',
								centerpinFill: '#ddd'
							}
						}).draw();
						
						const source_{{each["name"]}} = new EventSource("/OPCUAClient?node={{each['node']}}");
						source_{{each["name"]}}.onmessage = function (event) {
							const data = JSON.parse(event.data);
								meter_{{each["name"]}}.value = data.value;
								meter_{{each["name"]}}.grow();
						}
						
					{% endif %}
				
				
			{% endif %}
		{% endfor %}
		
		
	
	
	
		
    });
function hex_to_ascii(str1)
	 {
		var hex  = str1.toString();
		var str = '';
		for (var n = 0; n < hex.length; n += 2) {
			str += String.fromCharCode(parseInt(hex.substr(n, 2), 16));
		}
		return str;
	 }	
</script>
</body>
</html>